// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rosauth:srv/Authentication.idl
// generated code does not contain a copyright notice
#include "rosauth/srv/detail/authentication__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

// Include directives for member types
// Member `mac`
// Member `client`
// Member `dest`
// Member `rand`
// Member `level`
#include "rosidl_runtime_c/string_functions.h"
// Member `t`
// Member `end`
#include "builtin_interfaces/msg/detail/time__functions.h"

bool
rosauth__srv__Authentication_Request__init(rosauth__srv__Authentication_Request * msg)
{
  if (!msg) {
    return false;
  }
  // mac
  if (!rosidl_runtime_c__String__init(&msg->mac)) {
    rosauth__srv__Authentication_Request__fini(msg);
    return false;
  }
  // client
  if (!rosidl_runtime_c__String__init(&msg->client)) {
    rosauth__srv__Authentication_Request__fini(msg);
    return false;
  }
  // dest
  if (!rosidl_runtime_c__String__init(&msg->dest)) {
    rosauth__srv__Authentication_Request__fini(msg);
    return false;
  }
  // rand
  if (!rosidl_runtime_c__String__init(&msg->rand)) {
    rosauth__srv__Authentication_Request__fini(msg);
    return false;
  }
  // t
  if (!builtin_interfaces__msg__Time__init(&msg->t)) {
    rosauth__srv__Authentication_Request__fini(msg);
    return false;
  }
  // level
  if (!rosidl_runtime_c__String__init(&msg->level)) {
    rosauth__srv__Authentication_Request__fini(msg);
    return false;
  }
  // end
  if (!builtin_interfaces__msg__Time__init(&msg->end)) {
    rosauth__srv__Authentication_Request__fini(msg);
    return false;
  }
  return true;
}

void
rosauth__srv__Authentication_Request__fini(rosauth__srv__Authentication_Request * msg)
{
  if (!msg) {
    return;
  }
  // mac
  rosidl_runtime_c__String__fini(&msg->mac);
  // client
  rosidl_runtime_c__String__fini(&msg->client);
  // dest
  rosidl_runtime_c__String__fini(&msg->dest);
  // rand
  rosidl_runtime_c__String__fini(&msg->rand);
  // t
  builtin_interfaces__msg__Time__fini(&msg->t);
  // level
  rosidl_runtime_c__String__fini(&msg->level);
  // end
  builtin_interfaces__msg__Time__fini(&msg->end);
}

bool
rosauth__srv__Authentication_Request__are_equal(const rosauth__srv__Authentication_Request * lhs, const rosauth__srv__Authentication_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // mac
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->mac), &(rhs->mac)))
  {
    return false;
  }
  // client
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->client), &(rhs->client)))
  {
    return false;
  }
  // dest
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->dest), &(rhs->dest)))
  {
    return false;
  }
  // rand
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->rand), &(rhs->rand)))
  {
    return false;
  }
  // t
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->t), &(rhs->t)))
  {
    return false;
  }
  // level
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->level), &(rhs->level)))
  {
    return false;
  }
  // end
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->end), &(rhs->end)))
  {
    return false;
  }
  return true;
}

bool
rosauth__srv__Authentication_Request__copy(
  const rosauth__srv__Authentication_Request * input,
  rosauth__srv__Authentication_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // mac
  if (!rosidl_runtime_c__String__copy(
      &(input->mac), &(output->mac)))
  {
    return false;
  }
  // client
  if (!rosidl_runtime_c__String__copy(
      &(input->client), &(output->client)))
  {
    return false;
  }
  // dest
  if (!rosidl_runtime_c__String__copy(
      &(input->dest), &(output->dest)))
  {
    return false;
  }
  // rand
  if (!rosidl_runtime_c__String__copy(
      &(input->rand), &(output->rand)))
  {
    return false;
  }
  // t
  if (!builtin_interfaces__msg__Time__copy(
      &(input->t), &(output->t)))
  {
    return false;
  }
  // level
  if (!rosidl_runtime_c__String__copy(
      &(input->level), &(output->level)))
  {
    return false;
  }
  // end
  if (!builtin_interfaces__msg__Time__copy(
      &(input->end), &(output->end)))
  {
    return false;
  }
  return true;
}

rosauth__srv__Authentication_Request *
rosauth__srv__Authentication_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosauth__srv__Authentication_Request * msg = (rosauth__srv__Authentication_Request *)allocator.allocate(sizeof(rosauth__srv__Authentication_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rosauth__srv__Authentication_Request));
  bool success = rosauth__srv__Authentication_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rosauth__srv__Authentication_Request__destroy(rosauth__srv__Authentication_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rosauth__srv__Authentication_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rosauth__srv__Authentication_Request__Sequence__init(rosauth__srv__Authentication_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosauth__srv__Authentication_Request * data = NULL;

  if (size) {
    data = (rosauth__srv__Authentication_Request *)allocator.zero_allocate(size, sizeof(rosauth__srv__Authentication_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rosauth__srv__Authentication_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rosauth__srv__Authentication_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rosauth__srv__Authentication_Request__Sequence__fini(rosauth__srv__Authentication_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rosauth__srv__Authentication_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rosauth__srv__Authentication_Request__Sequence *
rosauth__srv__Authentication_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosauth__srv__Authentication_Request__Sequence * array = (rosauth__srv__Authentication_Request__Sequence *)allocator.allocate(sizeof(rosauth__srv__Authentication_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rosauth__srv__Authentication_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rosauth__srv__Authentication_Request__Sequence__destroy(rosauth__srv__Authentication_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rosauth__srv__Authentication_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rosauth__srv__Authentication_Request__Sequence__are_equal(const rosauth__srv__Authentication_Request__Sequence * lhs, const rosauth__srv__Authentication_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rosauth__srv__Authentication_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rosauth__srv__Authentication_Request__Sequence__copy(
  const rosauth__srv__Authentication_Request__Sequence * input,
  rosauth__srv__Authentication_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rosauth__srv__Authentication_Request);
    rosauth__srv__Authentication_Request * data =
      (rosauth__srv__Authentication_Request *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rosauth__srv__Authentication_Request__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rosauth__srv__Authentication_Request__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rosauth__srv__Authentication_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


bool
rosauth__srv__Authentication_Response__init(rosauth__srv__Authentication_Response * msg)
{
  if (!msg) {
    return false;
  }
  // authenticated
  return true;
}

void
rosauth__srv__Authentication_Response__fini(rosauth__srv__Authentication_Response * msg)
{
  if (!msg) {
    return;
  }
  // authenticated
}

bool
rosauth__srv__Authentication_Response__are_equal(const rosauth__srv__Authentication_Response * lhs, const rosauth__srv__Authentication_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // authenticated
  if (lhs->authenticated != rhs->authenticated) {
    return false;
  }
  return true;
}

bool
rosauth__srv__Authentication_Response__copy(
  const rosauth__srv__Authentication_Response * input,
  rosauth__srv__Authentication_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // authenticated
  output->authenticated = input->authenticated;
  return true;
}

rosauth__srv__Authentication_Response *
rosauth__srv__Authentication_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosauth__srv__Authentication_Response * msg = (rosauth__srv__Authentication_Response *)allocator.allocate(sizeof(rosauth__srv__Authentication_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rosauth__srv__Authentication_Response));
  bool success = rosauth__srv__Authentication_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rosauth__srv__Authentication_Response__destroy(rosauth__srv__Authentication_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rosauth__srv__Authentication_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rosauth__srv__Authentication_Response__Sequence__init(rosauth__srv__Authentication_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosauth__srv__Authentication_Response * data = NULL;

  if (size) {
    data = (rosauth__srv__Authentication_Response *)allocator.zero_allocate(size, sizeof(rosauth__srv__Authentication_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rosauth__srv__Authentication_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rosauth__srv__Authentication_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rosauth__srv__Authentication_Response__Sequence__fini(rosauth__srv__Authentication_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rosauth__srv__Authentication_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rosauth__srv__Authentication_Response__Sequence *
rosauth__srv__Authentication_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rosauth__srv__Authentication_Response__Sequence * array = (rosauth__srv__Authentication_Response__Sequence *)allocator.allocate(sizeof(rosauth__srv__Authentication_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rosauth__srv__Authentication_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rosauth__srv__Authentication_Response__Sequence__destroy(rosauth__srv__Authentication_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rosauth__srv__Authentication_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rosauth__srv__Authentication_Response__Sequence__are_equal(const rosauth__srv__Authentication_Response__Sequence * lhs, const rosauth__srv__Authentication_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rosauth__srv__Authentication_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rosauth__srv__Authentication_Response__Sequence__copy(
  const rosauth__srv__Authentication_Response__Sequence * input,
  rosauth__srv__Authentication_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rosauth__srv__Authentication_Response);
    rosauth__srv__Authentication_Response * data =
      (rosauth__srv__Authentication_Response *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rosauth__srv__Authentication_Response__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          rosauth__srv__Authentication_Response__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rosauth__srv__Authentication_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
